local Recount2 = Recount2
local tinsert = table.insert
local string_match = string.match
local string_gmatch = string.gmatch
local string_gsub = string.gsub
local string_sub = string.sub
local string_format = string.format
local string_rep = string.rep
local table_concat = table.concat
local math_floor = math.floor
local table_len

local tempTable = {}
local formatList = {}
local formatting
local function ProcessCompiledTagPhraseNoFormat(cTagPhrase, ...)
	local count = select("#", ...)
	local num = #formatList

	for i = 1, num do
		if i<=count then
			formatList[i] = "%s"
		else
			formatList[k] = nil
		end
	end

	formatting = table_concat(formatList, ', ')
	return string_format(formatting, ...)
end

local function ProcessCompiledTagPhraseFormat(cTagPhrase, ...)
	local recombine = cTagPhrase.recombineTable
	local formatStrings = cTagPhrase.formatStrings
	local nonNil = 0

	for i = 1, cTagPhrase.numArgs do
		local cur = select(i, ...)
		if cur~=nil then
			recombine[i] = formatStrings[i]
			nonNil = nonNil +1
			tempTable[nonNil] = cur
		else
			recombine[i] = '-'
		end
	end
	
	formatting = string_format(cTagPhrase.unformatted, unpack(recombine))
	return string_format(formatting, unpack(tempTable))
end

local function ProcessCompiledTagPhraseFormatNoNils(cTagPhrase, ...)
	return string_format(cTagPhrase.format, ...)
end


local function CompileTagPhrase(tagPhrase)
	local cTagPhrase = Recount2:GetTable()

	--Check to see do we have formatting info
	local tags, format=string.match(tagPhrase, '(.*):(.*)')

	if format then
		if string_sub(format, 1, 1)=="$" then
			cTagPhrase.format = string_sub(format, 2)
			cTagPhrase.func = ProcessCompiledTagPhraseFormatNoNils
		else
			tagPhrase = tags
			cTagPhrase.format = format
			cTagPhrase.formatStrings = Recount2:GetTable()
			cTagPhrase.recombineTable = Recount2:GetTable()
			local curLoc, endLoc, fString
			local numArgs = 0
			local unformatted = ""
			local lastLoc = 1
			curLoc, endLoc, fString = string.find(format, '(%%[%-%+ #0]*%d*%.?%d*[cdieEfgGosuxXq])')
			while curLoc do
				numArgs = numArgs + 1
				tinsert(cTagPhrase.formatStrings, fString)
				tinsert(cTagPhrase.recombineTable, '')
				unformatted = unformatted .. string.sub(format, lastLoc, curLoc-1) .. '%s'
				lastLoc = endLoc + 1
				curLoc, endLoc, fString = string.find(format, '(%%[%-%+ #0]*%d*%.?%d*[cdieEfgGosuxXq])', lastLoc)
			end
			unformatted = unformatted .. string.sub(format, lastLoc, -1)
			unformatted = string_gsub(unformatted, "%%%%", "%%%%%%%%")
			cTagPhrase.unformatted = unformatted
			cTagPhrase.numArgs = numArgs

			cTagPhrase.func = ProcessCompiledTagPhraseFormat
		end
	else
		cTagPhrase.func = ProcessCompiledTagPhraseNoFormat
	end
	--Compile the phrase
	cTagPhrase.code =  Recount2:CompileExpression(tags)

	return cTagPhrase
end

function Recount2:CompileTags(tags)
	compiledTags = Recount2:GetTable()
	compiledTags.cTagPhrases = Recount2:GetTable()

	--Need to search for tag phrases and compile them
	newStr = string_gsub(tags, "[%%]", "%%%0")
	for tagPhrase in string_gmatch(tags, '(%b[])') do
		tinsert(compiledTags.cTagPhrases, CompileTagPhrase(string_sub(tagPhrase,2,-2)))
		tagPhrase = string_gsub(tagPhrase, "[%^%$%(%)%%%.%[%]%*%+%-%?]", "%%%0")
		--Need to double the %'s to get it to match as well
		tagPhrase = string_gsub(tagPhrase, "%%%%", "%%%%%%%%")
		newStr=string_gsub(newStr, tagPhrase, '%%s', 1)
	end

	compiledTags.string = newStr

	return compiledTags
end

local tagResults = {}
function Recount2:ProcessCompiledTags(cTags, uniqueID)
	local phrases = #cTags.cTagPhrases
	for k in ipairs(tagResults) do
		if k>phrases then
			tagResults[k] = nil
		end
	end


	for k, cTagPhrase in ipairs(cTags.cTagPhrases) do
		tagResults[k] = cTagPhrase.func(cTagPhrase, cTagPhrase.code())
	end

	return string_gsub(string_format(cTags.string, unpack(tagResults)), '%%%%', '%%')
end

function Recount2:ProcessTags(tags)
	local cTags = Recount2:CompileTags(tags)
	local result = Recount2:ProcessCompiledTags(cTags)
	Recount2:FreeTableRecurse(cTags)
	return result
end